/*	ssl/kssl.h
**	19990701	VRS 	Started.
*/

#ifndef NO_KRB5

#ifndef	KSSL_H
#define	KSSL_H

#include <stdio.h>
#include <ctype.h>
#include <strings.h>
#include "krb5.h"

/*	Uncomment this to debug kssl problems or
**	to trace usage of the Kerberos session key
**
**	#define		KSSL_DEBUG
*/

#ifndef	KRB5SVC
#define KRB5SVC	"kssl"
#endif

#ifndef	KRB5KEYTAB
#define KRB5KEYTAB	"/etc/krb5.keytab.kssl"
#endif


#define	KSSL_ERR_MAX	255
typedef struct kssl_err_st  {
	int 	reason;
	char	text[KSSL_ERR_MAX+1];
	}	KSSL_ERR;


/*	Context for passing
**		(1) Kerberos session key to SSL, and 
**		(2)	Config data between application and SSL lib
*/
typedef struct kssl_ctx_st	{		/*	used by:	disposition:			*/
	char			*service_name;	/*	C,S 		default ok (kssl)		*/
	char			*service_host;	/*	C			input, REQUIRED   		*/
	char			*client_princ;	/*	  S			output from krb5 ticket	*/
	char			*keytab_file;	/*    S 		NULL (/etc/krb5.keytab)	*/
	krb5_enctype	enctype;
	int 			length;
	krb5_octet FAR	*key;
	}	KSSL_CTX;

#define	KSSL_CLIENT 	1
#define KSSL_SERVER 	2
#define	KSSL_SERVICE	3
#define	KSSL_KEYTAB 	4

#define KSSL_CTX_OK 	0
#define KSSL_CTX_ERR	1
#define KSSL_NOMEM		2


void			print_krb5_data(char *label, krb5_data *kdata);
void			print_krb5_authdata(char *label, krb5_authdata **adata);
void			print_krb5_keyblock(char *label, krb5_keyblock *keyblk);

char			*kstring(char *string);
char			*knumber(int len, krb5_octet *contents);


void			kssl_err_set(KSSL_ERR *kssl_err, int reason, char *text);

KSSL_CTX		*kssl_ctx_new(void);
KSSL_CTX		*kssl_ctx_free(KSSL_CTX *kssl_ctx);
void			kssl_ctx_show(KSSL_CTX *kssl_ctx);
krb5_error_code kssl_ctx_setkey(KSSL_CTX *kssl_ctx, krb5_keyblock *session);
krb5_error_code kssl_ctx_setstring(KSSL_CTX *kssl_ctx, int which, char *text);
krb5_error_code kssl_ctx_setprinc(KSSL_CTX *kssl_ctx, int which,
									krb5_data *realm, krb5_data *entity);

krb5_error_code	kssl_cget_tkt(KSSL_CTX *kssl_ctx,  krb5_data *ap_req,
								KSSL_ERR *kssl_err);
krb5_error_code	kssl_sget_tkt(KSSL_CTX *kssl_ctx,  char *msg, int msglen,
								KSSL_ERR *kssl_err);


#endif	/* KSSL_H 	*/
#endif	/* NO_KRB5	*/

